1 REM ERATOSTHENES SIEVE
2 REM http://en.wikipedia.org/wiki/Sieve_of_Eratosthenes
3 REM http://rosettacode.org/wiki/Sieve_of_Eratosthenes#Applesoft_BASIC
4 FAST

10 LET TRUE=(1=1)
11 LET FALSE=(1<>1)
12 LET LIMIT=1024
20 LET COUNT=0
30 REM NOS SINCLAIR, A BASE DO DIM EH 1
31 DIM F(LIMIT+1)
40 REM 0 E 1 NAO SAO PRIMOS, POR DEFINICAO
50 FOR I=1 TO 2
51 LET F(I)=FALSE
52 NEXT I
60 FOR I=3 TO LIMIT+1
61 LET F(I)=TRUE
62 NEXT I

1000 REM 
1010 LET NN=INT (SQR (LIMIT))
1011 FOR N=2 TO NN
1020 IF NOT F(N+1) THEN GO TO 1060
1030 FOR K=N*N TO LIMIT STEP N
1040 LET F(K+1)=FALSE
1050 NEXT K
1060 NEXT N
1070 REM COUNT THE PRIMES. LEMBRAR QUE O DIM NO SINCLAIR COMECA EM 1
1080 FOR N=0 TO LIMIT
1090 IF NOT F(N+1) THEN GO TO 1110
1100 LET COUNT=COUNT+1
1101 REM PRINT N;", ";
1110 NEXT N

9996 PRINT
9997 PRINT "FEITO: ";COUNT;" PRIMOS ENCONTRADOS."
9998 SLOW
9999 STOP
